Index: /extensions/PiwigoLib/PiwigoLib/DTO/Helper/PwgEnumHelper.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoLib/DTO/Helper/PwgEnumHelper.cs	(revision 13519)
+++ /extensions/PiwigoLib/PiwigoLib/DTO/Helper/PwgEnumHelper.cs	(revision 13520)
@@ -2,8 +2,9 @@
 using System.Reflection;
 using System.Xml.Serialization;
+using System.Collections.Generic;
 
 namespace Com.Piwigo.Lib.DTO.Helper
 {
-    internal static class PwgEnumHelper<T>
+    public static class PwgEnumHelper<T>
     {
         static PwgEnumHelper()
@@ -42,4 +43,16 @@
             throw new ArgumentException(String.Format("PwgEnumHelper<{0}>.enumValueOf({1}): The String is not a description or value of the specified enum.", typeof(T).Name, value));
         }
+
+        public static List<KeyValuePair<T, String>> buildChoiceList()
+        {
+            List<KeyValuePair<T, String>> lst = new List<KeyValuePair<T, String>>();
+
+            foreach (T item in Enum.GetValues(typeof(T)))
+	        {
+                lst.Add(new KeyValuePair<T, String>(item, StringValueOf(item)));
+	        }
+  
+            return lst;
+        }
     }
 }
Index: /extensions/PiwigoLib/PiwigoUpload/DTO/LocalPwgImage.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/DTO/LocalPwgImage.cs	(revision 13519)
+++ /extensions/PiwigoLib/PiwigoUpload/DTO/LocalPwgImage.cs	(revision 13520)
@@ -65,6 +65,6 @@
         }
 
-        private PwgConfidentLevelEnum? _confidentialLevel;
-        public PwgConfidentLevelEnum? ConfidentialLevel
+        private PwgConfidentLevelEnum _confidentialLevel;
+        public PwgConfidentLevelEnum ConfidentialLevel
         {
             set { _confidentialLevel = value; OnPropertyChanged("ConfidentialLevel"); }
Index: /extensions/PiwigoLib/PiwigoUpload/DTO/ModelManager.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/DTO/ModelManager.cs	(revision 13519)
+++ /extensions/PiwigoLib/PiwigoUpload/DTO/ModelManager.cs	(revision 13520)
@@ -72,4 +72,6 @@
             }
 
+            public System.Windows.Forms.TreeNode SelectedNode { get; set; }
+
             private LocalAlbum _AlbumEdited;
             public LocalAlbum AlbumEdited { 
@@ -148,4 +150,31 @@
                 } 
             }
+
+            private PwgUploadOption _uploadOption;
+            public PwgUploadOption UploadOption
+            { 
+                get {
+                    return _uploadOption;
+                }
+                set {
+                    _uploadOption = value;
+                    OnPropertyChanged("UploadOption"); 
+                } 
+            }
+
+            private List<KeyValuePair<PwgConfidentLevelEnum, String>> _lstConfidentLevel;
+            public List<KeyValuePair<PwgConfidentLevelEnum, String>> LstConfidentLevel
+            {
+                get
+                {
+                    return _lstConfidentLevel;
+                }
+                set
+                {
+                    _lstConfidentLevel = value;
+                    OnPropertyChanged("LstConfidentLevel"); 
+                }
+            }
+
 
             public ModelManagerBase()
@@ -157,4 +186,7 @@
                 AlbumEdited = new LocalAlbum();
                 ImageEdited = new LocalImage();
+                UploadOption = new PwgUploadOption();
+
+                LstConfidentLevel = Com.Piwigo.Lib.DTO.Helper.PwgEnumHelper<PwgConfidentLevelEnum>.buildChoiceList();
             }
 
@@ -178,4 +210,5 @@
                     PropertyChanged(this, new PropertyChangedEventArgs(info));
             }
+
         }
     }
Index: /extensions/PiwigoLib/PiwigoUpload/Helper/MainAppHelper.cs
===================================================================
--- /extensions/PiwigoLib/PiwigoUpload/Helper/MainAppHelper.cs	(revision 13519)
+++ /extensions/PiwigoLib/PiwigoUpload/Helper/MainAppHelper.cs	(revision 13520)
@@ -40,16 +40,20 @@
         internal static void BuildAlbumTree(System.Windows.Forms.TreeView aTree, LocalAlbumList lstAlbum)
         {
-            if (aTree.Nodes.Count > 0)
+            System.Windows.Forms.TreeNode root = aTree.Nodes[0];
+            if (root.Nodes.Count > 0)
             {
-                aTree.Nodes.Clear(); 
+                root.Nodes.Clear();
             }
+            //System.Windows.Forms.TreeNode root = new System.Windows.Forms.TreeNode("Albums", 0, 0);
+            //aTree.Nodes.Add(root);
+            //ModelManager.Instance.SelectedNode = root;
+            //aTree.SelectedNode = root;
 
-            System.Windows.Forms.TreeNode root = new System.Windows.Forms.TreeNode("Albums", 0, 0);
-            aTree.Nodes.Add(root);
-            
             foreach (LocalAlbum Alb in lstAlbum)
 	        {
                 root.Nodes.Add(buildAlbumToNode(Alb));
 	        }
+
+            aTree.ExpandAll();
         }
 
